function a3fSol
%
%  Aufgabe 3f.
%  Name: 
%
% A3F solves the initial value problem from 3e with the linear implicit
% midpoint rule and the matlab solver ode45.
  
  y0 = [1;1;1]/sqrt(3);
  T = [0; 5];
  h = 0.1;

% Implement the right hand side and Jacobi matrix here:
% Note: t is a 'dummy' variable to make the functions ode45-compatible.
  a = [1;0;0]; c = 1;
  f = @(t,y) cross(a,y) + c*cross(y,cross(a,y));
% or
% f = @(t,y) [c*(y(2)^2 + y(3)^2);  -(y(3) + c*y(1)*y(2));  y(2) - c*y(1)*y(3);];
% Jacobi for a=(1,0,0)
  df = @(t,y) [0, 2*c*y(2), 2*c*y(3); -c*y(2), -c*y(1), -1; -c*y(3), 1, -c*y(1)];

% Solve the IVP with LinImpMidPointSolve and ode45 here:
  [t,yLinIMP] = LinImpMidPointSolveSol(f,df,y0,T,h);
  [tRef,yRef] = ode45(f,T,y0,odeset('Abstol',1e-8,'Reltol',1e-8));
  
% Plot the first component of the solutions here:
  figure;
  plot(t,yLinIMP(1,:),'+-',tRef,yRef(:,1));
  title('{\bf Aufgabe 3: Solution with ode45 and LinImpMidPointSolveSol}')
  legend('LinIMP','ode45');
  
